
#include <stdio.h>
#include <math.h>

typedef struct Vector {
    double x,y;
} Vector;

typedef struct Particle {
    Vector r;
    Vector v;
    Vector f;
} Particle;

typedef struct ParticleList {
    Particle *p;
    struct ParticleList *next;
} ParticleList;

extern Particle *new_Particle(double x, double y, double vx, double vy);
extern double Dt;
extern double Mass;

extern void  forces(ParticleList *l,double (*force_func)(double r));
extern void  integrate(ParticleList *l);
extern double force_invr(double);
extern double force_lj(double);







